#include <avr/io.h>
#include <stdlib.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <inttypes.h>
#include "ffft.h"

int16_t input[FFT_N];         /* input buffer */
complex_t buffer[FFT_N];     /* FFT buffer */
uint16_t output[FFT_N/2];     /* output buffer */

void ADC_init(void)
{
    ADMUX = 0;
    ADMUX |= (1 << MUX0);
    ADMUX |= (1 << REFS0);
    ADCSRA = 0;
    ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0); //set clock prescaler at 128
    ADCSRA |= (1 << ADEN);
}

int ADC_get(uint8_t channel)
{
    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

    ADCSRA |= (1 << ADSC);
    while(ADCSRA & (1 << ADSC));

    return ADC;
}

int main() 
{

	DDRB = 0xFF; //setare pini
	DDRC = 0xFF;
	DDRD = 0b10111111;
	DDRA = 0b10000000;
    ADC_init();
    int i = 0, j = 0;

    while(1) {
    	input[i] = ADC_get(0);
    	i++;

    	if (i == 63) {
    		fft_input(input, buffer);
    		fft_execute(buffer);
    		fft_output(buffer, output);

    		for (j = 0; j < 2; j++) {
    			if (output[j] > 5) {
   					PORTA = 0;
   					PORTD = 0b00001000;
					PORTC = 0b01100000;
					PORTB = 0b00101000;
    			}
    		}


    		for (j = 2; j < 4; j++) {
    			if (output[j] > 5) {
   					PORTD = 0b00001000;
					PORTC = 0b00011111;
					PORTA = 0b10000000;
					PORTB = 0b11010111;
    			}
    		}


    		for (j = 4; j < 6; j++) {
    			if (output[j] > 5) {
    				PORTA = 0;
					PORTD = 0b00000100;
					PORTC = 0b01100000;
					PORTB = 0b00101000;
    			}
    		}

    		for (j = 6; j < 8; j++) {
    			if (output[j] > 5) {
					PORTD = 0b00000100;
					PORTC = 0b00011111;
					PORTA = 0b10000000;
					PORTB = 0b11010111;
    			}
    		}


    		for (j = 8; j < 10; j++) {
    			if (output[j] > 5) {
    				PORTA = 0;
					PORTD = 0b00000010;
					PORTC = 0b01100000;
					PORTB = 0b00101000;
    			}
    		}


    		for (j = 10; j < 12; j++) {
    			if (output[j] > 5) {
					PORTD = 0b00000010;
					PORTC = 0b00011111;
					PORTA = 0b10000000;
					PORTB = 0b11010111;
    			}
    		}


    		for (j = 12; j < 14; j++) {
    			if (output[j] > 5) {
    				PORTA = 0;
					PORTD = 0b00000001;
					PORTC = 0b01100000;
					PORTB = 0b00101000;
    			}
    		}



    		for (j = 14; j < 16; j++) {
    			if (output[j] > 5) {
					PORTD = 0b00000001;
					PORTC = 0b00011111;
					PORTA = 0b10000000;
					PORTB = 0b11010111;
    			}
    		}



    		i = 0;
    		_delay_ms(200);

			PORTA = 0;
			PORTB = 0;
			PORTC = 0;
			PORTD = 0;
    	}
    }
}
